<?php
/** 
*
* Module Breizh ajax checks
* @version $Id: ajaxchecks.php 130 16:14 19/05/2012 Sylver35 Exp $ 
* @copyright (c) 2010, 2012 Breizh Portal  http://breizh-portal.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Check that the $_POST['mode'] variable has been set
if (!isset($_POST['mode']))
{
	return_ajax();
}

// Set the variables
$mode 		= request_var('mode', '');
$username 	= replaceCaracter(utf8_normalize_nfc(request_var('username', '', true)));
$password1 	= replaceCaracter(utf8_normalize_nfc(request_var('password1', '', true)));
$password2 	= replaceCaracter(utf8_normalize_nfc(request_var('password2', '', true)));
$email1 	= replaceCaracter(strtolower(utf8_normalize_nfc(request_var('email1', '', true))));
$email2 	= replaceCaracter(strtolower(utf8_normalize_nfc(request_var('email2', '', true))));
$length1 	= request_var('length1', 0);
$length2 	= request_var('length2', 0);

// The inclusion of language files must be here for the swappable language
// Automatic change language (¦-)
$use_lang = request_var('lang', $user->lang_name);
$user->lang_name = $use_lang;
$user->lang = array();
$user->data['user_lang'] = $user->lang_name;
$user->add_lang(array('common', 'ucp', 'mods/ajaxchecks'));

$go 		= $mode. '||&nbsp;&nbsp;';
$_tpl_no 	= '&nbsp;<span style="color:#FF0000;">';
$_tpl_ok 	= '&nbsp;<span style="color:#008000;">';
$_tpl_end 	= '</span>';

switch ($mode)
{
	case 'usernamecheck':
		// Check that the username given has not already been used
		// Verifie the length before
		if ($length1 < $config['min_name_chars']) // if username is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_USERNAME') . $_tpl_no . $user->lang['TOO_SHORT_USERNAME'] . $_tpl_end);
		}
		else if ($length1 > $config['max_name_chars']) // if username is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_USERNAME') . $_tpl_no . $user->lang['TOO_LONG_USERNAME'] . $_tpl_end);
		}
		
		$checkresult = validate_username($username);
		
		// Check if it the username is ok (false means it is)
		if ($checkresult === false) // if username doesn't exist and respect the obligations
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_TRUE'] . $_tpl_end;
		}
		else // if the username already exists or does not respect the obligations
		{
			$return = $go . $user->img('icon_ajax_false', $checkresult . '_USERNAME') . $_tpl_no . $user->lang[$checkresult . '_USERNAME'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'usernamecur':
		// Check that the username given has not already been used
		// Verifie the length before
		if ($length1 < $config['min_name_chars']) // if username is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_USERNAME') . $_tpl_no . $user->lang['TOO_SHORT_USERNAME'] . $_tpl_end);
		}
		else if ($length1 > $config['max_name_chars']) // if username is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_USERNAME') . $_tpl_no . $user->lang['TOO_LONG_USERNAME'] . $_tpl_end);
		}
		
		$checkresult = validate_username($username);
		
		// Check if it the username is ok (false means it is)
		if ($checkresult === false) // if username doesn't exist and respect the obligations
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_TRUE'] . $_tpl_end;
		}
		else // if the username already exists or does not respect the obligations
		{
			return_ajax($go . $user->img('icon_ajax_false', $checkresult . '_USERNAME') . $_tpl_no . $user->lang[$checkresult . '_USERNAME'] . $_tpl_end);
		}
		
		if ($username == $user->data['username']) // it's actual username?
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_USERNAME_CUR') . $_tpl_ok . $user->lang['AJAX_CHECK_USERNAME_CUR'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'passwordcheck':
		// Check that the two passwords given are the same
		// Verifie the length before
		if ($length1 < $config['min_pass_chars'])// if password1 is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_SHORT_NEW_PASSWORD'] . $_tpl_end);
		}
		else if ($length1 > $config['max_pass_chars']) // if password1 is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_LONG_NEW_PASSWORD'] . $_tpl_end);
		}
		if ($length2 < $config['min_pass_chars']) // if password2 is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_PASSWORD_CONFIRM') . $_tpl_no . $user->lang['TOO_SHORT_PASSWORD_CONFIRM'] . $_tpl_end);
		}
		else if ($length2 > $config['max_pass_chars']) // if password2 is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_PASSWORD_CONFIRM') . $_tpl_no . $user->lang['TOO_LONG_PASSWORD_CONFIRM'] . $_tpl_end);
		}
		if ($length2 > $length1) // If the passwords are different lengths
		{
			return_ajax($go . $user->img('icon_ajax_false', 'AJAX_CHECK_PASSWORD_BIG') . $_tpl_no . $user->lang['AJAX_CHECK_PASSWORD_BIG'] . $_tpl_end);
		}
		if ($user->data['is_registered']) // Only in page i=profile&mode=reg_details for the current password in use
		{
			$same_password = phpbb_check_hash($password2, $user->data['user_password']);
			if ($same_password)
			{
				return_ajax($go . $user->img('icon_ajax_false', 'SAME_PASSWORD_ERROR') . $_tpl_no . $user->lang['SAME_PASSWORD_ERROR'] . $_tpl_end);
			}
		}
		
		// Check the password doesn't contain any illegal chars, etc.
		$checkresult = validate_password($password1);
		
		// Check if the password is ok (false means it is)
		if ($checkresult === false)
		{
			// Check if the passwords are the same
			if ($password1 == $password2)
			{
				// Passwords are the same, show a correct message
				$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_TRUE'] . $_tpl_end;
			}
			else
			{
				// Passwords not the same, show the error
				$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_PASSWORD_FALSE') . $_tpl_no . $user->lang['AJAX_CHECK_PASSWORD_FALSE'] . $_tpl_end;
			}
		}
		else
		{
			// Failed the password validation
			$error_lang = (!isset($user->lang[$checkresult . '_NEW_PASSWORD'])) ? $checkresult : $user->lang[$checkresult . '_NEW_PASSWORD'];
			$return = $go . $user->img('icon_ajax_false', $error_lang) . $_tpl_no . $error_lang . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;
	
	case 'strength';
	case 'strengthcur';
		if ($length1 < $config['min_pass_chars'])// if password1 is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_SHORT_NEW_PASSWORD'] . $_tpl_end);
		}
		else if ($length1 > $config['max_pass_chars']) // Check if password is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_LONG_NEW_PASSWORD'] . $_tpl_end);
		}
		// Check the "strength" of the password and show an image accordingly
		$strength = check_password_strength($password1, $length1);
		if (!$strength)
		{
			$return = '';
		}
		else if (!validate_password($password1))
		{
			$return = $go . $user->img('icon_ajax_strength_' .$strength['number'], 'AJAX_CHECK_PASSWORD_STRENGTH') . '&nbsp;&nbsp;' .sprintf($user->lang['AJAX_CHECK_PASSWORD_STRENGTH_' .$strength['number']], $strength['color']). '</span>';
		}
		else
		{
			$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_PASSWORD_FALSE') . $_tpl_no . $user->lang['AJAX_CHECK_PASSWORD_FALSE'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'emailcheck';
		// Check that the two email addresses given are the same
		// Verifie the length
		if ($length2 < 10) // if email is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_EMAIL') . $_tpl_no . $user->lang['TOO_SHORT_EMAIL'] . $_tpl_end);
		}
		
		// Check the email is not in use, has the correct format, is for a "real" domain, etc.
		$checkresult = validate_email($email1);
		
		// Check if it the email is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the email validation
			$fail = !isset($user->lang[$checkresult. '_EMAIL']) ? utf8_normalize_nfc($checkresult) : $user->lang[$checkresult. '_EMAIL'];
			$raison = sprintf($user->lang['AJAX_CHECK_INVALID_EMAIL'], $fail);
			$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FAIL') . '&nbsp;' . $raison;
		}
		else
		{
			// Now check both are the same
			if ($email1 == $email2)
			{
				$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_EMAIL_TRUE') . $_tpl_ok . $user->lang['AJAX_CHECK_EMAIL_TRUE'] . $_tpl_end;
			}
			else
			{
				$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FALSE') . $_tpl_no . $user->lang['AJAX_CHECK_EMAIL_FALSE'] . $_tpl_end;
			}
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'checkemail':
		// Check that the two email addresses given are the same
		// Verifie the length
		if ($length1 < 10) // if email is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_EMAIL') . $_tpl_no . $user->lang['TOO_SHORT_EMAIL'] . $_tpl_end);
		}
		
		// Check the email is not in use, has the correct format, is for a "real" domain, etc.
		$checkresult = validate_email($email1);
		
		// Check if it the email is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the email validation
			$raison = sprintf($user->lang['AJAX_CHECK_INVALID_EMAIL'], ((!isset($user->lang[$checkresult. '_EMAIL'])) ? utf8_normalize_nfc($checkresult) : $user->lang[$checkresult. '_EMAIL']));
			$return = $go . $user->img('icon_ajax_false', 'AJAX_CHECK_EMAIL_FAIL') . '&nbsp;' . $raison;
		}
		// Only in page i=profile&mode=reg_details for the current email in use
		else if ($user->data['is_registered'] && $email1 == $user->data['user_email'])
		{
			return_ajax($go . $user->img('icon_ajax_true', 'AJAX_CHECK_EMAIL_TRUE_FIRST') . $_tpl_ok . $user->lang['AJAX_CHECK_EMAIL_CURRENT'] . $_tpl_end);
		}
		else
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_EMAIL_TRUE_FIRST') . $_tpl_ok . $user->lang['AJAX_CHECK_EMAIL_TRUE_FIRST'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'passwordcur':

		$check_password = phpbb_check_hash($password1, $user->data['user_password']);
		
		if ($check_password !== false)
		{
			$return = $go . $user->img('icon_ajax_false', 'SAME_PASSWORD_ERROR') . $_tpl_no . $user->lang['SAME_PASSWORD_ERROR'] . $_tpl_end;
		}
		else
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_OK') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_OK'] . $_tpl_end;
		}

		// Verifie the length
		if ($length1 < $config['min_pass_chars'])// if password is too small
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_SHORT_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_SHORT_NEW_PASSWORD'] . $_tpl_end);
		}
		else if ($length1 > $config['max_pass_chars']) // if password is too long
		{
			return_ajax($go . $user->img('icon_ajax_false', 'TOO_LONG_NEW_PASSWORD') . $_tpl_no . $user->lang['TOO_LONG_NEW_PASSWORD'] . $_tpl_end);
		}
		
		// Check the password doesn't contain any illegal chars, etc.
		$checkresult = validate_password($password1);
		
		// Check if it the password is ok (false means it is)
		if ($checkresult !== false)
		{
			// Failed the password validation
			$error_lang = (!isset($user->lang[$checkresult . '_NEW_PASSWORD'])) ? $checkresult : $user->lang[$checkresult . '_NEW_PASSWORD'];
			$return = $go . $user->img('icon_ajax_false', $error_lang) . $_tpl_no . $error_lang . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;

	case 'oldpassword':
		
		$check_password = phpbb_check_hash($password1, $user->data['user_password']);
		
		if ($check_password !== false)
		{
			$return = $go . $user->img('icon_ajax_true', 'AJAX_CHECK_PASSWORD_OK') . $_tpl_ok . $user->lang['AJAX_CHECK_PASSWORD_OK'] . $_tpl_end;
		}
		else
		{
			return_ajax($go . $user->img('icon_ajax_false', 'CUR_PASSWORD_ERROR') . $_tpl_no . $user->lang['CUR_PASSWORD_ERROR'] . $_tpl_end);
		}
		
		// Now check both are the same
		if ($password1 == $password2)
		{
			$return = $go . $user->img('icon_ajax_false', 'SAME_PASSWORD_ERROR') . $_tpl_no . $user->lang['SAME_PASSWORD_ERROR'] . $_tpl_end;
		}
		
		// Stop execution and show the result
		return_ajax($return);
	break;
	
	default:
		// Dunno what we are doing so return
		return_ajax();
	break;
}

// Now, check the "strength" of the password 
// show an image and color text accordingly
function check_password_strength($password, $length)
{
	$return = array('number' => 0, 'color' => '',);
	$patterns = array('#[a-z]#','#[A-Z]#','#[0-9]#','/[¬!"£$%^&*()`{}\[\]:@~;\'#<>?,.\/\\-=_+\|]/');
	foreach($patterns as $pattern)
	{
		if (preg_match($pattern, $password, $matches))
		{
			$return['number']++;
		}
	}
	
	if ($length < 7 && $return['number'] > 1)
	{
		// If the length is less than 7 maximum can be rating can be 2
		$return['number'] = 1;
	}
	else if ($length < 9 && $return['number'] > 2)
	{
		// If the length is less than 9 maximum can be rating can be 2
		$return['number'] = 2;
	}
	else if ($length >= 10 && $return['number'] != 4)
	{
		// If the length is 10 or more then give it one higher rating (unless 4 already)
		$return['number']++;
	}
	switch ($return['number'])
	{
		case 1:
			$return['color'] = '<span style="color:red;">';
		break;
		case 2:
			$return['color'] = '<span style="color:darkorange;">';
		break;
		case 3:
			$return['color'] = '<span style="color:royalblue;">';
		break;
		case 4:
			$return['color'] = '<span style="color:green;">';
		break;
	}
	return $return['number'] ? $return : '';
}

// Little magic to prevent bug with somes caracters
function replaceCaracter($value)
{
	$value = str_replace(array('%26', '&amp;'), '&', $value);
	//$value = str_replace(array('|||', '||||'), array('<', '>'), $value);//, '|--|', '+'
	return $value;
}

// Function for a nice output
function return_ajax($value = '')
{
	echo($value);
	exit_handler();
}

?>